MODULE settings_MODIS_sample
  INTEGER, PARAMETER :: SP = KIND (1.0E0)   ! single precision
  INTEGER, PARAMETER :: DP = KIND (1.0D0)   ! double precision
  INTEGER, PARAMETER :: max_len = 256    ! Maximum length of character
  INTEGER, PARAMETER :: max_file_name = max_len

  INTEGER, PARAMETER :: i_error = -9999
  REAL, PARAMETER :: r_error = -9999.0

  REAL, PARAMETER :: r_eps   = 1.0E-4

! +++ Input/Output files
! CHARACTER(LEN=max_file_name) :: l2_file

! +++ Data structures
  TYPE baseparam
    INTEGER(SP) :: utc_time
    INTEGER(SP) :: granule
    INTEGER(SP) :: yy, mm, dd, doy
    INTEGER(SP) :: iunit, ounit
    CHARACTER(LEN=max_file_name) :: input_path, ifile_name
    CHARACTER(LEN=max_file_name) :: work_path
    CHARACTER(LEN=max_file_name) :: ifile, ofile
    CHARACTER(LEN=8) :: cyyyymmdd
    CHARACTER(LEN=4) :: cHHMM
    CHARACTER(LEN=4) :: ver_num   ! Terra, Aqua: ".006"

!!! product_ID = Case aerosol, Terra: "MOD04_L2", Aqua: "MYD04_L2"
    CHARACTER(LEN=20) :: product_ID

    CHARACTER(LEN=max_file_name) :: my_name
    CHARACTER(LEN=max_file_name) :: exec_prog

  END TYPE baseparam

  TYPE swath_param
    INTEGER(SP) :: sw_id    ! swath ID
    INTEGER(SP) :: sd_id    ! file ID
    INTEGER(SP) :: utc_time     ! UTC time
    CHARACTER(LEN=4) :: cHHMM   ! UTC time in character
    CHARACTER(LEN=max_file_name) :: ifile
  END TYPE swath_param

! +++ Output: MOD04_L2, MYD04_L2 (aerosol product)
  TYPE modis_out
    REAL(SP)  ylat, xlon

    REAL(SP)  AOD         ! Aerosol Optical Depth
    INTEGER(2)  AOD_flag
  END TYPE modis_out

END MODULE settings_MODIS_sample
